Given an array arr[] consisting of N positive integers and an integer K, which represents the maximum number that can be added to the array elements. The task is to maximize the length of the longest possible subarray of equal elements by adding at most K.
Examples:
Input: arr[] = {3, 0, 2, 2, 1}, k = 3
Output: 4
Explanation:
Step 1: Adding 2 to arr[1] modifies array to {3, 2, 2, 2, 1}
Step 2: Adding 1 to arr[4] modifies array to {3, 2, 2, 2, 2}
Therefore, answer will be 4 ({arr[1], …, arr[4]}).
Input: arr[] = {1, 1, 1}, k = 7
Output: 3
Explanation:
All array elements are already equal. Therefore, the length is 3.
Approach: Follow the steps below to solve the problem:
- Sort the array arr[]. Then, use Binary Search to pick a possible value for the maximum indices having the same element.
- For each picked_value, use the Sliding Window technique to check if it is possible to make all elements equal for any subarray of size picked_value.
- Finally, print the longest possible length of subarray obtained.
Below is the implementation for the above approach:
C++14
#include <bits/stdc++.h>
using namespace std;
bool check(vector< int > pSum, int len, int k,
vector< int > a)
{
int i = 0;
int j = len;
while (j <= a.size())
{
int maxSize = a[j - 1];
int totalNumbers = maxSize * len;
int currNumbers = pSum[j] - pSum[i];
if (currNumbers + k >= totalNumbers)
{
return true ;
}
else
{
i++;
j++;
}
}
return false ;
}
int maxEqualIdx(vector< int > arr, int k)
{
sort(arr.begin(), arr.end());
vector< int > prefixSum(arr.size());
prefixSum[1] = arr[0];
for ( int i = 1;
i < prefixSum.size() - 1; ++i)
{
prefixSum[i + 1] = prefixSum[i] +
arr[i];
}
int max = arr.size();
int min = 1;
int ans = 1;
while (min <= max)
{
int mid = (max + min) / 2;
if (check(prefixSum, mid, k, arr))
{
ans = mid;
min = mid + 1;
}
else
{
max = mid - 1;
}
}
return ans;
}
int main()
{
vector< int > arr = { 1, 1, 1 };
int k = 7;
cout << (maxEqualIdx(arr, k));
}
|
Java
import java.util.*;
class GFG {
public static int maxEqualIdx( int [] arr,
int k)
{
Arrays.sort(arr);
int [] prefixSum
= new int [arr.length + 1 ];
prefixSum[ 1 ] = arr[ 0 ];
for ( int i = 1 ; i < prefixSum.length - 1 ;
++i) {
prefixSum[i + 1 ]
= prefixSum[i] + arr[i];
}
int max = arr.length;
int min = 1 ;
int ans = 1 ;
while (min <= max) {
int mid = (max + min) / 2 ;
if (check(prefixSum, mid, k, arr)) {
ans = mid;
min = mid + 1 ;
}
else {
max = mid - 1 ;
}
}
return ans;
}
public static boolean check( int [] pSum,
int len, int k,
int [] a)
{
int i = 0 ;
int j = len;
while (j <= a.length) {
int maxSize = a[j - 1 ];
int totalNumbers = maxSize * len;
int currNumbers = pSum[j] - pSum[i];
if (currNumbers + k >= totalNumbers) {
return true ;
}
else {
i++;
j++;
}
}
return false ;
}
public static void main(String[] args)
{
int [] arr = { 1 , 1 , 1 };
int k = 7 ;
System.out.println(maxEqualIdx(arr, k));
}
}
|
Python3
def maxEqualIdx(arr, k):
arr.sort()
prefixSum = [ 0 ] * ( len (arr) + 1 )
prefixSum[ 1 ] = arr[ 0 ]
for i in range ( 1 , len (prefixSum) - 1 , 1 ):
prefixSum[i + 1 ] = prefixSum[i] + arr[i]
max = len (arr)
min = 1
ans = 1
while ( min < = max ):
mid = ( max + min ) / / 2
if (check(prefixSum, mid, k, arr)):
ans = mid
min = mid + 1
else :
max = mid - 1
return ans
def check(pSum, lenn, k, a):
i = 0
j = lenn
while (j < = len (a)):
maxSize = a[j - 1 ]
totalNumbers = maxSize * lenn
currNumbers = pSum[j] - pSum[i]
if (currNumbers + k > = totalNumbers):
return True
else :
i + = 1
j + = 1
return False
arr = [ 1 , 1 , 1 ]
k = 7
print (maxEqualIdx(arr, k))
|
C#
using System;
class GFG{
public static int maxEqualIdx( int [] arr,
int k)
{
Array.Sort(arr);
int [] prefixSum = new int [arr.Length + 1];
prefixSum[1] = arr[0];
for ( int i = 1;
i < prefixSum.Length - 1; ++i)
{
prefixSum[i + 1] = prefixSum[i] + arr[i];
}
int max = arr.Length;
int min = 1;
int ans = 1;
while (min <= max)
{
int mid = (max + min) / 2;
if (check(prefixSum, mid, k, arr))
{
ans = mid;
min = mid + 1;
}
else
{
max = mid - 1;
}
}
return ans;
}
public static bool check( int [] pSum,
int len, int k,
int [] a)
{
int i = 0;
int j = len;
while (j <= a.Length)
{
int maxSize = a[j - 1];
int totalNumbers = maxSize * len;
int currNumbers = pSum[j] - pSum[i];
if (currNumbers + k >= totalNumbers)
{
return true ;
}
else
{
i++;
j++;
}
}
return false ;
}
public static void Main(String[] args)
{
int [] arr = {1, 1, 1};
int k = 7;
Console.WriteLine(maxEqualIdx(arr, k));
}
}
|
Javascript
<script>
function maxEqualIdx(arr, k)
{
arr.sort();
let prefixSum
= new Array(arr.length + 1).fill(0);
prefixSum[1] = arr[0];
for (let i = 1; i < prefixSum.length - 1;
++i) {
prefixSum[i + 1]
= prefixSum[i] + arr[i];
}
let max = arr.length;
let min = 1;
let ans = 1;
while (min <= max) {
let mid = Math.floor((max + min) / 2);
if (check(prefixSum, mid, k, arr)) {
ans = mid;
min = mid + 1;
}
else {
max = mid - 1;
}
}
return ans;
}
function check(pSum, len, k, a)
{
let i = 0;
let j = len;
while (j <= a.length) {
let maxSize = a[j - 1];
let totalNumbers = maxSize * len;
let currNumbers = pSum[j] - pSum[i];
if (currNumbers + k >= totalNumbers) {
return true ;
}
else {
i++;
j++;
}
}
return false ;
}
let arr = [ 1, 1, 1 ];
let k = 7;
document.write(maxEqualIdx(arr, k));
</script>
|
Time Complexity: O(N * log N)
Auxiliary Space: O(N)
Feeling lost in the world of random DSA topics, wasting time without progress? It's time for a change! Join our DSA course, where we'll guide you on an exciting journey to master DSA efficiently and on schedule.
Ready to dive in? Explore our Free Demo Content and join our DSA course, trusted by over 100,000 geeks!
Last Updated :
05 May, 2021
Like Article
Save Article